function [waves Mean_Duration average_velocity_seg average_velocity_dom] = Velocity(threshold)
file= csvread('waves_total.txt');

V= csvread('waves_total.txt');
V= V(find(V(:,4)>1),:);

Duration= V(:,4)';
Duration= Duration'; 
Duration = Duration(sum(isnan(Duration),2)==0); 
Duration= Duration(sum(isinf(Duration),2)==0);

Mean_Duration= sum(Duration)/length(Duration)

file_test= file(:,4);
file_a= file(:,4);

% wave duration
waves= file_a(file_a>0);


unique_list= unique(file_a);

%% thresholda
findindices= find(file_test<threshold & file_test>0);
findnegindices = -findindices;

unique_list= unique_list(unique_list<0);

unique_list= setdiff([unique_list],[findnegindices]);
%% end

a= zeros(unique_list,2);
e= 1;

for i = 1: length(unique_list);
  try
  
 test = unique_list(i);
%here you can choose specific waves if needs be for images e.g = test= -1,-2,-277

indices= find(file_a == test);
indices_2= file(indices,:);
indices_3= indices_2(1,4);

%start_segment
ss= file(abs(indices_3),3);
%start_domain
sd= file(abs(indices_3),2);

indices_ss= find(indices_2(:,3)==ss);
indices_sd= find(indices_2(:,2)==sd);

% can be used to see through which seg/dom it goes for fixed dom/seg
test_ss= indices_2(indices_ss,:);
test_sd= indices_2(indices_sd,:);

csvwrite('wave_matrix_segments.txt', test_ss);
csvwrite('wave_matrix_domains.txt', test_sd);

%file with the absolute distance can be used as the starter wave
compare_ss= file(abs(indices_3),:) - test_ss;
compare_sd= file(abs(indices_3),:) - test_sd;

csvwrite('wave_start_points.txt', file(abs(indices_3),:));


domains_crossed= max(abs(compare_ss(:,2)));
segments_crossed= max(abs(compare_sd(:,3)));

%% over time %%
start_time= file(abs(indices_3),:);
start_time= start_time(1,1);

end_time_ss= abs(compare_ss);
end_time_sd= abs(compare_sd);

end_time_dc= find(end_time_ss(:,2)==domains_crossed);
end_time_dc= end_time_dc(1);
end_time_sc= find(end_time_sd(:,3)== segments_crossed);
end_time_sc= end_time_sc(1);

end_time_domain= end_time_ss(end_time_dc,1);
end_time_segment= end_time_sd(end_time_sc,1);

velocity_s = segments_crossed/end_time_segment;
velocity_d = domains_crossed/end_time_domain;

a(e,1)= (velocity_s);
a(e,2)= (velocity_d);

e=e+1;

  catch exception
    continue

end
  end
    

a= a(all(~isnan(a),2),:);
a= a(all(~isinf(a),2),:);

average_velocity_seg= sum(a(:,1))/length(a(:,1))
average_velocity_dom= sum(a(:,2))/length(a(:,2))
waves= length(unique_list)
end

